
.include	"pmio.asm"

#-------------------------------------- RAM ---------------------------------
.orgfill 0x1000   # first part of RAM is VRAM
.orgfill 0x1800
#position:
#    .db 0

#--------------------------------- HARDWARE REGS ----------------------------
.orgfill 0x2000
hwregs:    

#---------------------------- CART INTERRUPT HANDLERS -----------------------
.orgfill 0x2100   # "MN" ID
.db "MN"
#INT #0
.orgfill 0x2102   #GAME START
    jmp start
#INT #1    
.orgfill 0x2108   #V-BLANK
    jmp unhandled_interrupt
#INT #2
.orgfill 0x210E   #V-DRAW
    jmp unhandled_interrupt
#INT #3
.orgfill 0x2114   #TIMER 2 OVERFLOW
    jmp unhandled_interrupt
#INT #4
.orgfill 0x211A   # 
    jmp unhandled_interrupt
#INT #5
.orgfill 0x2120   #TIMER 1 OVERFLOW
    jmp unhandled_interrupt
#INT #6
.orgfill 0x2126   # 
    jmp unhandled_interrupt
#INT #7
.orgfill 0x212C   #TIMER 3 OVERFLOW
    jmp unhandled_interrupt
#INT #8
.orgfill 0x2132   #TIMER 3 OVERFLOW
    jmp unhandled_interrupt
#INT #9
.orgfill 0x2138   # 
    jmp unhandled_interrupt
#INT #10
.orgfill 0x213E   # 
    jmp unhandled_interrupt
#INT #11
.orgfill 0x2144   # 
    jmp unhandled_interrupt
#INT #12
.orgfill 0x214A   # 
    jmp unhandled_interrupt
#INT #13
.orgfill 0x2150   #IR RECEIVE LOW TO HIGH
    jmp unhandled_interrupt
#INT #14
.orgfill 0x2156   #SHOCK DETECTOR
    jmp unhandled_interrupt
#INT #15
.orgfill 0x215C   #KEY PRESS: POWER BUTTON
    jmp unhandled_interrupt
#INT #16
.orgfill 0x2162   #KEY PRESS: D-PAD RIGHT
    jmp unhandled_interrupt
#INT #17
.orgfill 0x2168   #KEY PRESS: D-PAD LEFT
    jmp unhandled_interrupt
#INT #18
.orgfill 0x216E   #KEY PRESS: D-PAD DOWN
    jmp int_key_down
#INT #19
.orgfill 0x2174   #KEY PRESS: D-PAD UP
    jmp int_key_up
#INT #20
.orgfill 0x217A   #KEY PRESS: C KEY
    jmp unhandled_interrupt
#INT #21
.orgfill 0x2180   #KEY PRESS: B KEY
    jmp unhandled_interrupt
#INT #22
.orgfill 0x2186   #KEY PRESS: A KEY
    jmp unhandled_interrupt
#INT #23
.orgfill 0x218C   # 
    jmp unhandled_interrupt
#INT #24
.orgfill 0x2192   # 
    jmp unhandled_interrupt
#INT #25
.orgfill 0x2198   # 
    jmp unhandled_interrupt
    
.orgfill 0x219E   
## 0
    
#-------------------------------- CART HEADER -------------------------------
.orgfill 0x21A4 
.db "NINTENDO"         # magic signature checked by the BIOS
.db "PTRI"             # game code - 4 byte
.db "POKETRIS____"     # name of rom, 12 chars max
.orgfill 0x21Bc
.db "2P"               

#--------------------------------- CART MAIN --------------------------------
.orgfill 0x21D0

unhandled_interrupt:
    reti

int_key_up:
    
    movb	[nn+REG_INT_FLAG2],IF_KEY_B
    cmp a,0
    jz nodec
    dec a
nodec:

    reti

int_key_down:
    
    movb	[nn+REG_INT_FLAG2],IF_KEY_B
    cmp a,$40
    jz noinc
    inc a
noinc:

    reti


start:


    mov   sp, $2000    # set SP
    movw  nn, REG_BASE           # NN reg always point to hardware regs
    movb  [nn+REG_LCD_CNT0], (LCD0_TILEBG|LCD0_RENDER)     # set tiled mode 12x8, non-inverted
    movb  [nn+REG_LCD_CNT1], LCD1_ENABLE1        # enable video
    
    mov   [nn+REG_EVENT2S],INT2S_KEY_UP|INT2S_KEY_DOWN	# Interrupt Enable
    mov   [nn+REG_EVENT2P],INT2P_KEYPAD	# Master Enable
    mov   flags,0			# get irqs working in minimon


    mov  x1, tiles           # set tiles graphix base
    mov [REG_BASE+REG_LCD_TILEBGMEM],x1

    call loadmap
    mov  a, $0

main_game:

    mov [REG_BASE+REG_BGMOV_V], a

    jmp main_game

        
loadmap:

    mov x1,mdat
    mov x2,TILEMAP      # we copy the first level
    mov l,$0
copy_level:
    mov a,[x1]
    mov [x2],a
    inc x1
    inc x2
    inc l
    cmp l,192
    jnz copy_level


   
   
   
   
    ret

mdat:
.incbin testmap.bin

### tile data (align 8 bytes)
.align	8
tiles:
.incbin pttiles.bin
